unit hiMMFClient;

interface

uses Kol,Share,Windows,Debug;

type
  THIMMFClient = class(TDebug)
   private
    BufSize:cardinal;
    SendMMF, RecMMF: THandle;
    SendData, RecData: PChar;
    MMFName: string;
    wsSize, rdSize:DWORD;
    wsData:string;
   public
    _prop_Name:string;
    _data_Name:THI_Event;
    _prop_Computer:string;

    _data_Data:THI_Event;
    _data_Computer:THI_Event;
    _event_onStatus:THI_Event;
    _event_onAnswer:THI_Event;

    constructor Create;
    destructor Destroy; override;
    procedure _work_doWrite(var _Data:TData; Index:word);
    procedure _work_doAnswer(var _Data:TData; Index:word);
  end;

implementation

constructor THIMMFClient.Create;
var   lpSystemInfo:_SYSTEM_INFO;
begin
   inherited;
   FillChar(lpSystemInfo, Sizeof(lpSystemInfo), #0);
   GetSystemInfo(lpSystemInfo);;
   BufSize := lpSystemInfo.dwAllocationGranularity;
end;

destructor THIMMFClient.Destroy;
begin
   if Assigned(SendData) then begin
      UnmapViewOfFile(SendData);
      SendData := nil;
   end;
   if SendMMF <> 0 then CloseHandle(SendMMF);
   SendMMF := 0;
   if RecMMF <> 0 then CloseHandle(RecMMF);
   RecMMF := 0;
   inherited;
end;

procedure THIMMFClient._work_doWrite;
begin
   SendMMF := 0;
   SendData := nil;
   wsSize := INVALID_HANDLE_VALUE;
TRY
   MMFName := ReadString(_Data, _data_Name, _prop_Name);
   if MMFName = '' then exit;
   wsData := ReadString(_Data, _data_Data);
   SendMMF := OpenFileMapping(FILE_MAP_ALL_ACCESS, False, PChar(MMFName));
   if SendMMF = 0 then exit;
   wsSize := 0;
   SendData := MapViewOfFile(SendMMF, FILE_MAP_WRITE, 0, 0, 0);
   if SendData <> nil then begin
      wsSize := min(BufSize - sizeof(wsSize), length(wsData));
      Move(wsSize, SendData[0], sizeof(wsSize));  
      Move(wsData[1], SendData[sizeof(wsSize)], wsSize); 
      // ",  "
      UnmapViewOfFile(SendData);
      SendData := nil;
   end;
   CloseHandle(SendMMF);
   SendMMF := 0;
FINALLY
   _hi_OnEvent(_event_onStatus, integer(wsSize));
END;
end;

procedure THIMMFClient._work_doAnswer;
begin
   RecData := nil;
   rdSize := INVALID_HANDLE_VALUE;
TRY
   MMFName := ReadString(_Data, _data_Name, _prop_Name);
   if MMFName = '' then exit;
   RecMMF := OpenFileMapping(FILE_MAP_READ, False, PChar(MMFName));
   if RecMMF = 0 then exit;   
   RecData := MapViewOfFile(RecMMF, FILE_MAP_READ, 0, 0, 0);
   if RecData <> nil then begin
      Move(RecData[0], rdSize, sizeof(rdSize));
      // ",  "
      UnmapViewOfFile(RecData);
      RecData := nil;
   end;  
   CloseHandle(RecMMF);
   RecMMF := 0;
FINALLY
   _hi_onEvent(_event_onAnswer, integer(rdSize));
END;   
end;

end.