unit hiMMFServer;

interface

uses Windows,Kol,Share,Debug;

type
  THIMMFServer = class(TDebug)
   private
    BufSize:cardinal;
    RecData: PChar;
    hMMF: THandle;
    MMFName: string;
    rdSize:DWORD;
    rdData:string;
    procedure Stop;
   public
    _prop_Name:string;
    _data_Name:THI_Event;

    _event_onStatus:THI_Event;
    _event_onRead:THI_Event;

    constructor Create;
    destructor Destroy; override;
    procedure _work_doCreate(var _Data:TData; Index:word);
    procedure _work_doRead(var _Data:TData; Index:word);
    procedure _work_doDestroy(var _Data:TData; Index:word);
  end;

implementation

constructor THIMMFServer.Create;
var   lpSystemInfo:_SYSTEM_INFO;
begin
   inherited;
   FillChar(lpSystemInfo, Sizeof(lpSystemInfo), #0);
   GetSystemInfo(lpSystemInfo);;
   BufSize := lpSystemInfo.dwAllocationGranularity;
end;

destructor THIMMFServer.Destroy;
begin
   Stop;
   inherited;
end;

procedure THIMMFServer._work_doCreate;
var   Status: integer;
begin
   Status := 0;
TRY
   MMFName := ReadString(_Data, _data_Name, _prop_Name);
   if (MMFName = '') or (hMMF <> 0) then exit;
   hMMF := CreateFileMapping(INVALID_HANDLE_VALUE, nil, PAGE_READWRITE, 0, BufSize, PChar(MMFName));
   if (hMMF <> 0) and (GetLastError = NO_ERROR) then
      Status := 1 
   else if (hMMF <> 0) and (GetLastError <> NO_ERROR) then
      Stop;
FINALLY
   _hi_OnEvent(_event_onStatus, Status);
END;         
end;

procedure THIMMFServer.Stop;
begin
   if Assigned(RecData) then begin
      UnmapViewOfFile(RecData);
      RecData := nil;
   end;
   if hMMF <> 0 then CloseHandle(hMMF);
   hMMF := 0;
end;

procedure THIMMFServer._work_doDestroy;
begin
   Stop;
end;

procedure THIMMFServer._work_doRead;
begin
   RecData := nil;
   rdData := '';
TRY
   if not((MMFName = '') or (hMMF = 0)) then begin
      RecData := MapViewOfFile(hMMF, FILE_MAP_WRITE, 0, 0, 0);
      if RecData <> nil then begin
         Move(RecData[0], rdSize, sizeof(rdSize));
         if rdSize = 0 then exit;
         SetLength(rdData, rdSize);
         Move(RecData[sizeof(rdSize)], rdData[1], rdSize);       
         rdSize := 0; 
         Move(rdSize, RecData[0], sizeof(rdSize));
         // ",  "
         UnmapViewOfFile(RecData);
         RecData := nil;
      end;
   end;
FINALLY
   _hi_onEvent(_event_onRead, rdData);   
END;
end;

end.